// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_navigation_msgs:msg/CommandWithHandshake.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_navigation_msgs/msg/command_with_handshake.hpp"


#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__COMMAND_WITH_HANDSHAKE__TRAITS_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__COMMAND_WITH_HANDSHAKE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_navigation_msgs/msg/detail/command_with_handshake__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace automotive_navigation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CommandWithHandshake & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: msg_counter
  {
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << ", ";
  }

  // member: command
  {
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CommandWithHandshake & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: msg_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << "\n";
  }

  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CommandWithHandshake & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_navigation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_navigation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_navigation_msgs::msg::CommandWithHandshake & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_navigation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_navigation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_navigation_msgs::msg::CommandWithHandshake & msg)
{
  return automotive_navigation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_navigation_msgs::msg::CommandWithHandshake>()
{
  return "automotive_navigation_msgs::msg::CommandWithHandshake";
}

template<>
inline const char * name<automotive_navigation_msgs::msg::CommandWithHandshake>()
{
  return "automotive_navigation_msgs/msg/CommandWithHandshake";
}

template<>
struct has_fixed_size<automotive_navigation_msgs::msg::CommandWithHandshake>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<automotive_navigation_msgs::msg::CommandWithHandshake>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<automotive_navigation_msgs::msg::CommandWithHandshake>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__COMMAND_WITH_HANDSHAKE__TRAITS_HPP_
